<?php
//======================
//Author:  AppleGrew (www.applegrew.com)
//License: GPL version 2
//Version: 1.3
//======================

//=============
//Configurables
//=============
$TITLE = 'Apple Grew\'s Flickr Interestigness';
$BY = 'http://www.applegrew.com';
$MSG = 'Thou shall not steal.';
$LINK = 'http://www.applegrew.com/util/if.xml';
$bind_address = "127.0.0.1"; //Set this to "" if you do not want it to be bound to any IP.
//====END=======

//Code from http://in2.php.net/manual/en/features.commandline.php#75110.
//Slightly modified to allow '_' in arguments.
//To pass arguments use the syntax: php -q iflickr.php --arg1=value1 --arg2==value2 --arg3
//Result: Array( ['arg1'] => value1, ['arg2'] => value2, ['arg3'] => true )
function arguments($argv) {
    $_ARG = array();
    foreach ($argv as $arg) {
        if (preg_match('/--[a-zA-Z0-9_]*=.*/',$arg)) {
            $str = explode("=",$arg); $arg = '';
            $key = preg_replace("/--/",'',$str[0]);
            for ( $i = 1; $i < count($str); $i++ ) {
                $arg .= $str[$i];
            }
            $_ARG[$key] = $arg;
        } elseif(preg_match('/-[a-zA-Z0-9]/',$arg)) {
            $arg = preg_replace("-",'',$arg);
            $_ARG[$arg] = 'true';
        }  
    }

return $_ARG;
}

function msgdie($msg){
    echo $msg;
    echo '
    </channel>
</rss>';
    exit(1);
}

//===============================================================
//Verifying $_SERVER["SERVER_ADDR"] to enforce binding of address.
//===============================================================
if($bind_address != "" && isset($_SERVER["SERVER_ADDR"]) && $_SERVER["SERVER_ADDR"]!=$bind_address){
    echo "
<html>
    <head>
    <title>${TITLE}</title>
    </head>
    <body>
        <br><br><center><b>You are not allowed to run this script.</b></center><br>
    </body>
</html>";

exit(1);
}

//==================================================
//Fetching arguments from command line if applicable.
//==================================================
if(!isset($_GET['api_key'])){    //This argument MUST be set. If not then let's now read from the commandline.
    $_GET = arguments($_SERVER['argv']);
}

//=============================
//Read paramenters from _GET[].
//=============================
if(isset($_GET['api_key']))
    $api_key = $_GET['api_key'];
else
    $api_key = "NoKeyGiven";

if(isset($_GET['per_pg']))
    $per_pg = $_GET['per_pg'];
else
    $per_pg = 10;

if(isset($_GET['pg']))
    $pg = $_GET['pg'];
else
    $pg = "1";

if(isset($_GET['thumbnail_type'])) //Any picture type, viz - Square,
                                   //Thumbnail, Small, Medium or Large,
                                   //can be used as thumbnail.
                                   //Pls note that type if not available
                                   //for that picture then it won't be displayed.
                                   //If this is not set then all possible pic
                                   //sizes would be added as thumbnails, with the bigger pics at the top.
    $thumb_type = $_GET['thumbnail_type'];
else
    $thumb_type = "";

if(isset($_GET['min_size'])) //If set then the pic which is equal or just larger than this dimension will be chosen as thumbnail.
    $min_size = intval($_GET['min_size']);
else
    $min_size = 0;

//=======================
//Creating the mRSS file.
//=======================
header('Content-type: text/xml');
echo '<?xml version="1.0" encoding="utf-8"?>
<?xml-stylesheet type="text/xsl" href="mrss.xsl" ?>
<rss version="2.0" xmlns:media="http://search.yahoo.com/mrss/">
    <channel>
        <title>'.$TITLE.'</title>
        <link>'.$LINK.'</link>
        <description>'.$MSG.'</description>
        <generator>'.$BY.'</generator>
';


//==========================
//Getting List of Licenses.
//==========================
#
# build the API URL to call
#
$params = array(
    'api_key'    => $api_key,
    'method'    => 'flickr.photos.licenses.getInfo',
    'format'    => 'php_serial',
);
$encoded_params = array();
foreach ($params as $k => $v){
    $encoded_params[] = urlencode($k).'='.urlencode($v);
}

#
# call the API and decode the response
#
$url = "http://api.flickr.com/services/rest/?".implode('&', $encoded_params);
$rsp = file_get_contents($url);
$rsp_obj = unserialize($rsp);

#
# Creating licenes_map (or an error if it failed)
#
if ($rsp_obj['stat'] == 'ok'){
    $licences_map = array();
    foreach ($rsp_obj['licenses']['license'] as $license){
        $licenses_map[$license['id']] = array('name' => htmlspecialchars($license['name']), 'url' => $license['url']);
    }


    //================================
    //Getting List of Interesting Pics.
    //================================
    #
    # build the API URL to call
    #
    $params = array(
        'api_key'    => $api_key,
        'method'    => 'flickr.interestingness.getList',
        'per_page' => $per_pg,
        'page' => $pg,
        'format'    => 'php_serial',
    );
    $encoded_params = array();
    foreach ($params as $k => $v){
        $encoded_params[] = urlencode($k).'='.urlencode($v);
    }

    #
    # call the API and decode the response
    #
    $url = "http://api.flickr.com/services/rest/?".implode('&', $encoded_params);
    $rsp = file_get_contents($url);
    $rsp_obj = unserialize($rsp);

    #
    # display the photo title (or an error if it failed)
    #
    if ($rsp_obj['stat'] == 'ok'){
    
        foreach ($rsp_obj['photos']['photo'] as $photo){
            echo '
                <item>
            ';
            $photo_title = htmlspecialchars($photo['title']);

            //=================
            //Getting Pic Info.
            //=================
            #
            # build the API URL to call
            #
            $params = array(
                'api_key'    => $api_key,
                'method'    => 'flickr.photos.getInfo',
                'photo_id'    => $photo['id'],
                'format'    => 'php_serial',
            );
            $encoded_params = array();
            foreach ($params as $k => $v){
                $encoded_params[] = urlencode($k).'='.urlencode($v);
            }

            #
            # call the API and decode the response
            #
            $url = "http://api.flickr.com/services/rest/?".implode('&', $encoded_params);
            $rsp = file_get_contents($url);
            $rsp_obj = unserialize($rsp);

            #
            # display the photo title (or an error if it failed)
            #
            if ($rsp_obj['stat'] == 'ok'){
                $photo_description = htmlspecialchars($rsp_obj['photo']['description']['_content']);
                foreach ($rsp_obj['photo']['urls']['url'] as $url){
                    if($url['type']=="photopage") {
                        $photopage_url = $url['_content'];
                    }
                }

                $photo_author = htmlspecialchars($rsp_obj['photo']['owner']['realname']);
                $photo_license = $rsp_obj['photo']['license'];
            }else{
                msgdie("
        <title>Call Failed: ".$rsp_obj['message']."</title>
    </item>");
            }
            //====================

            //================
            //Getting Pic Urls.
            //================
            #
            # build the API URL to call
            #
            $params = array(
                'api_key'    => $api_key,
                'method'    => 'flickr.photos.getSizes',
                'photo_id'    => $photo['id'],
                'format'    => 'php_serial',
            );
            $encoded_params = array();
            foreach ($params as $k => $v){
                $encoded_params[] = urlencode($k).'='.urlencode($v);
            }

            #
            # call the API and decode the response
            #
            $url = "http://api.flickr.com/services/rest/?".implode('&', $encoded_params);
            $rsp = file_get_contents($url);
            $rsp_obj = unserialize($rsp);

            #
            # display the photo title (or an error if it failed)
            #
            if ($rsp_obj['stat'] == 'ok'){
                $photo_url = array(
                    'url' => '',
                    'width' => '',
                    'height' => '',
                );
                $thumb_url = array();
                $got_thumb = false;
                foreach ($rsp_obj['sizes']['size'] as $pic){
                    //$rsp_obj has smallest pic at top and grows larger as we go down.
                    if(($thumb_type=="" && $min_size==0) ||
                       (!$got_thumb && $thumb_type!="" && $pic['label']==$thumb_type) ||
                       (!$got_thumb && $min_size !=0
                         && (intval($pic['height']) >= $min_size
                           || intval($pic['width']) >= $min_size))){

                        $thumb = array(
                            'url' => '',
                            'width' => '',
                            'height' => '',
                        );
                        $thumb['url'] = $pic['source'];
                        $thumb['width'] = $pic['width'];
                        $thumb['height'] = $pic['height'];                   
                        $thumb_url[] = $thumb;
                    
                        $got_thumb = true;
                    }

                    if($pic['label']=="Medium" || $pic['label']=="Large" || $pic['label']=="Original"){
                        //Not all pics have the Large size and the largest pic is allways at the end.
                        //My aim is to get the largest size.
                        $photo_url['url'] = $pic['source'];
                        $photo_url['width'] = $pic['width'];
                        $photo_url['height'] = $pic['height'];
                    }
                }

                //We need to reverse the array to place the bigger pics near the top.
                $thumb_url = array_reverse($thumb_url);
            }else{
                msgdie("
        <title>Call Failed: ".$rsp_obj['message']."</title>
    </item>");
            }
            //====================

            //===============
            //echoing to mRss
            //===============
            echo '
                <title>'.$photo_title.'</title>
                <link>'.$photo_url['url'].'</link>
                <description>
                    &lt;a href=&quot;'.$photopage_url.'&quot;&gt;&lt;img style=&quot;max-width:1024px;&quot;
                        src=&quot;'.$photo_url['url'].'&quot;/&gt;&lt;/a&gt;&lt;br&gt;
                    '.$photo_author.' &amp;copy;
                    &lt;a href=&quot;'.$licenses_map[$photo_license]['url'].'&quot;&gt;'.$licenses_map[$photo_license]['name'].'&lt;/a&gt;&lt;br&gt;
                    '.$photo_description.'
                </description>
                <author>'.$photo_author.'</author>
                <media:backLinks>
                    <media:backLink>'.$photopage_url.'</media:backLink>
                </media:backLinks>
                <media:content url="'.$photo_url['url'].'"
                    type="image/jpeg"
                    height="'.$photo_url['height'].'"
                    width="'.$photo_url['width'].'"/>
                <media:title>'.$photo_title.'</media:title>
                <media:text>'.$photo_description.'</media:text>
                <media:copyright url="'.$licenses_map[$photo_license]['url'].'">
                    '.$licenses_map[$photo_license]['name'].'
                </media:copyright>';
                    foreach( $thumb_url as $thumb ){
                        echo '
                <media:thumbnail url="'.$thumb['url'].'" height="'.$thumb['height'].'" width="'.$thumb['width'].'" />';
                    }
                    echo '
                <media:credit role="photographer">'.$photo_author.'</media:credit>
            </item>
            ';
        }
    }else{

        msgdie("
        <item>
            <title>Call Failed: ".$rsp_obj['message']."</title>
        </item>");
    }
}else{

    msgdie("
    <item>
        <title>Call Failed: ".$rsp_obj['message']."</title>
    </item>");
}
//====================

echo '
    </channel>
</rss>
';
?>