<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:media="http://search.yahoo.com/mrss/">
<xsl:output method="html"/>
<xsl:template match="/">
    <!--
        Author: AppleGrew (www.applegrew.com)
        License: GPL v2
        Please do not hot link to this file. If you need it, download it and host yourself.
    -->
    <html>
        <head>
            <title><xsl:value-of select="//rss/channel/title"/></title>
            <link rel="stylesheet" href="rss.css" type="text/css" media="all"/>
            <script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.7.1/jquery.min.js"/>
            <xsl:text disable-output-escaping="yes">
            <![CDATA[
            <script type="text/javascript">
                var lt = /&lt;/g, gt = /&gt;/g;
                $(function processMediaText() {
                    $('.mediaText').each(function process() {
                        var txt = $(this).text();
                        txt = txt.replace(lt, '<').replace(gt, '>');
                        $(this).html(txt);
                    });
                });
            </script>
            ]]>
            </xsl:text>
        </head>
        <body>
            <div id="feedHeaderContainer">
              <div id="feedHeader">
                <div id="feedTitle">
                    <div id="feedTitleContainer">
                        <h1><xsl:value-of select="//rss/channel/title"/></h1>
                        <h2><xsl:value-of select="//rss/channel/description"/></h2>
                    </div>
                </div>
                <div id="feedGenerator"><h4>Generated by <xsl:value-of select="//rss/channel/generator"/></h4></div>
              </div>
            </div>
            <div id="feedBody">
                
                <div id="feedContent">
                <xsl:for-each select="//rss/channel/item">
                    <div class="entry">
                        <h3>
                            <xsl:value-of select="title"/> by <a href="{media:backLinks/*[1]}"><xsl:value-of select="author"/></a>
                        </h3>
                        <div class="feedEntryContent">
                            <a href="{media:content/@url}" title="Click to view only this image.">
                                <img src="{media:content/@url}"/>
                            </a>
                            <br/>
							<xsl:value-of select="author"/> &#169; <a href="{media:copyright/@url}"><xsl:value-of select="media:copyright"/></a>
							<br/>
                            <pre class="mediaText">
                                <xsl:value-of select="media:text"/>
                            </pre>
                        </div>
                        <div class="enclosures">
                            Media files
                            <div class="enclosure">
                                <img src="File1616.png" class="type-icon"/>
                                <a href="{media:content/@url}">Original</a>
                                (Preview Document)
                                <br/>
                                <img src="File1616.png" class="type-icon"/>
                                <a href="{media:thumbnail/@url}">Thumbnail</a>
                                (Preview Document)
                            </div>
                        </div>
                    </div>
                    <div style="clear: both;"></div>
                    <hr/>
                </xsl:for-each>
                </div>
            </div>
        </body>
    </html>
</xsl:template>
</xsl:stylesheet>